
CEAAGENTDIR=/opt/IBM/TCIM/actuator
#!/sbin/sh
#######################
# Copyright (c) IBM Corp. 1998,2007. All Rights Reserved.
#####################

# Kill the named process(es).
# $1=<search pattern for your process>
killproc() {
    echo "Killing process with $1"
    pid=`ps -elf | grep "$1" | grep -v "grep $1" | awk '{print $4}'`
    if [ "X$pid" != "X" ]; then
        if kill -9 "$pid"; then
            echo "$1 stopped"
        else
            rval=1
            echo "Unable to stop $1"
        fi
    fi
}

get_cea_agent_id () {
  for word in `egrep "12.1.[0-9]+" $CEAAGENTDIR/start-client`
  do
    echo $word | egrep "12.1.[0-9]+" > /dev/null
    if [ $? -eq 0 ]
    then
      echo $word
      return 0
    fi
  done
  return 1
}

rm -f /sbin/rc2.d/S900cea_actuator
rm -f /sbin/rc1.d/K101cea_actuator
rm -f /sbin/rc1.d/K100cea_watchdog
rm -f /sbin/rc2.d/S901cea_watchdog
rm -f /sbin/init.d/cea.watchdog
rm -f /sbin/init.d/cea.actuator

CEAAGENTID=`get_cea_agent_id`

killproc "watchdog $CEAAGENTID"
killproc "agent $CEAAGENTID"

rm -r $CEAAGENTDIR

