#!/bin/sh

echo "Start time:"
date

if [ $# -ne 1 ]; then
	echo "Usage: aix-failedlogin-orig.sh <temp file name>"
	exit -1
fi;

if [ -z "$PROPSFILE" ]; then 
	echo "Value of environment variable PROPSFILE is incorrect."
	exit -1
fi;

TEMPfile=$1

echo "Parameters passed: $*"

#F0 Check for existing of PROPSFILE.aix-failedlogin.original. If file exist:
if [ -f $PROPSFILE.aix-failedlogin.original ]; then 
	#F0.1 Rename it to TEMPFILE5 filename
	mv $PROPSFILE.aix-failedlogin.original $TEMPfile
	
	if [ $? -ne 0 ]; then
		echo "Can't rename $PROPSFILE.aix-failedlogin.original $TEMPfile"
		exit -2
	fi;
else
	#F0.2 Create empty file TEMPFILE5. Return error code.
	echo "There is no $PROPSFILE.aix-failedlogin.original file"
	cat /dev/null > $TEMPfile
	if [ $? -ne 0 ]; then
		echo "Can't create empty file"
		exit -3
	fi;

	exit -4
fi;

echo "End time:"
date

exit 0
