#!/bin/sh

echo "Start time:"
date

if [ $# -ne 1 ]; then
	echo "Usage: aix-wtmp-orig.sh <temp file name>"
	exit -1
fi;

if [ -z "$PROPSFILE" ]; then 
	echo "Value of environment variable PROPSFILE is incorrect."
	exit -1
fi;

TEMPfile=$1

echo "Parameters passed: $*"

#E0 Check for existing of PROPSFILE.aix-wtmp.original. If file exist:
if [ -f $PROPSFILE.aix-wtmp.original ]; then 
	#E0.1 Rename it to TEMPFILE4 filename
	mv $PROPSFILE.aix-wtmp.original $TEMPfile
	
	if [ $? -ne 0 ]; then
		echo "Can't rename $PROPSFILE.aix-wtmp.original $TEMPfile"
		exit -2
	fi;
else
	#E0.2 Create empty empty file TEMPFILE4. Return error code.
	echo "There is no $PROPSFILE.aix-wtmp.original file"
	cat /dev/null > $TEMPfile
	if [ $? -ne 0 ]; then
		echo "Can't create empty file"
		exit -3
	fi;

	exit -4
fi;

echo "End time:"
date

exit 0
