#!/bin/sh

echo "Start time:"
date

if [ $# -ne 1 ]; then
        echo "Usage: aix-wtmp.sh <temp file name>"
        exit -1
fi;

if [ -z "$PROPSFILE" ]; then 
        echo "Value of environment variable PROPSFILE is incorrect."
        exit -1
fi;

TEMPfile=$1

echo "Parameters passed: $*"

#B0. Run the executable collect-utmp (see description below) with command line option (-w).
#    The result of collected WTMP information will be stored in TEMPFILE%N% file (ObjVal format) and
#    PROPSFILE.aix-wtmp.original (Original Format).

# usage of collect-utmp
# collect-utmp -w|-f -o <objval out file> -orig <original log out file> -s <state db file name>
../bin/collect-utmp -w -o $TEMPfile -orig $PROPSFILE.aix-wtmp.original -s $PROPSFILE.wtmp

ERRORCODE=$?
if [ $ERRORCODE -ne 0 ]; then
        echo "collect-utmp failed with code $ERRORCODE"
        exit -2
fi;

if [ ! -f $TEMPfile ]; then
        echo "File $TEMPfile was not generated!"
        exit -3
fi; 

if [ ! -f $PROPSFILE.aix-wtmp.original ]; then
        echo "File $PROPSFILE.aix-wtmp.original was not generated!"
        exit -4
fi; 

echo "End time:"
date

exit 0
