REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off

rem getting input parameters (step 1)
set TEMP_FILE1=%1
set TEMP_FILE2=%2
set TEMP_FILE3=%3
set TEMP_FILE4=%4
set INSTANCE_ARCHIVE_PATH=%~5
set INSTANCE_FILE_PATTERN=%6
set DATABASE_ARCHIVE_PATH=%~7
set DATABASE_FILE_PATTERN=%8
set InstanceName=%9
shift /1
set PROPS_FILE=%9

rem for different DB2 copies
set db2_tool=db2
set db2cmd_tool=db2cmd
set db2audit_tool=db2audit
set /A InstanceFound=0
set ILIST="%PROPS_FILE%.dir\list.txt"
rem end


rem internal variables
rem creating temp directory
mkdir %PROPS_FILE%.dir
set ACTUATOR_LOG="..\log\%PROPS_FILE%.log"
set ARCHLIST_TMP="%PROPS_FILE%.dir\archlist_tmp.txt"
set ARCHLIST="%PROPS_FILE%.dir\archlist.txt"
rem each archive will be extracted into this file
set TMP_FC_FILE="%PROPS_FILE%.dir\tmp_fc_file.txt"
rem defining %DATE_BEFORE% - the variable which contains time 2 days before current (contains . before digits)
for /F %%i in ('..\bin\date.exe +"%%Y%%m%%d%%H%%M%%S" -d "2 days ago"') do set DATE_BEFORE_INST=.%%i
set DATE_BEFORE_DB=%DATE_BEFORE_INST%
if exist %TMP_FC_FILE% del %TMP_FC_FILE%
set ALL_INST_ARCHLIST="%PROPS_FILE%.dir\all_inst_archlist.txt"
set ALL_DB_ARCHLIST="%PROPS_FILE%.dir\all_db_archlist.txt"
set TEMP_PROPS_FILE="%PROPS_FILE%.dir\props_file.tmp"
set NEW_PROPS_FILE="%PROPS_FILE%.dir\props_file.new"
rem file where output of "db2 list database directory" will be stored
set DATABASE_LIST_TMP="%PROPS_FILE%.dir\database_list_tmp.txt"
rem the same - final list
set DATABASE_LIST="%PROPS_FILE%.dir\database_list.txt"
rem temporary props file for each database
rem set LAST_FILE_DB="%PROPS_FILE%.dir\last_file_db.txt"
rem temporary file for storing DATE_BEFORE_DB variable
set TMPFILE="%PROPS_FILE%.dir\tmpfile.txt"
set ERROR_MESSAGE=
set ERROR_FLAG=0
set /A line=0
setlocal EnableDelayedExpansion

rem removing actuator log in order to create new
echo %date% %time% Processing started. > %ACTUATOR_LOG%

rem checking input parameters
if %TEMP_FILE1%=="" (
 echo %date% %time% 1-st sublog name is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %TEMP_FILE2%=="" (
 echo %date% %time% 2-nd sublog name is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %TEMP_FILE3%=="" (
 echo %date% %time% 3-d sublog name is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %TEMP_FILE4%=="" (
 echo %date% %time% 4-th sublog name is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if "%INSTANCE_ARCHIVE_PATH%"=="" (
 echo %date% %time% Instance level archive path is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %INSTANCE_FILE_PATTERN%=="" (
 echo %date% %time% Instance level pattern is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if "%DATABASE_ARCHIVE_PATH%"=="" (
 echo %date% %time% Database level archive path is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %DATABASE_FILE_PATTERN%=="" (
 echo %date% %time% Database level pattern is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %InstanceName%=="" (
 echo %date% %time% Instance name is not defined. Exiting. > %ACTUATOR_LOG%
 exit /b 1
)

if %PROPS_FILE%=="" (
 echo %date% %time% PROPSFILE is not defined > %ACTUATOR_LOG%
 exit /b 1
)

rem checking whether %PROPS_FILE% exists

rem redefining DATE_BEFORE_INST if collect isn't initial
if exist %PROPS_FILE% (
 for /F "tokens=1,2 delims='='" %%i in (%PROPS_FILE%) do (
	 if "%%i"=="lastinstfile" (
	     for /F %%n in ("%%j") do set DATE_BEFORE_INST=%%~xn
        )
    )
)

rem switching to the target instance
set DB2INSTANCE=%InstanceName%
db2cmd.exe -c -w "db2 -r %TMPFILE% get instance"
if %ERRORLEVEL% NEQ 0 (
     rem echo %date% %time% Unable to switch instance due to db2 run error.>> %ACTUATOR_LOG%
     rem echo %date% %time% Collect failed. >> %ACTUATOR_LOG%
     rem exit /b 1
     rem ---
     db2swtch -l > %ILIST%
     for /F "tokens=1,*" %%i in ('find /v /i "default" %ILIST%') do (
         if %%j GTR . (
             if not "%%j" == "%ILIST%" (
                 for /F  "delims=" %%k in ('echo %%j\') do (
                     for /F "delims=" %%x in ('"%%~pdkbin\db2ilist"') do (
                         if "%%x" == "%InstanceName%" (
                             set db2audit_tool=%%~pdkbin\db2audit.exe
                             set db2cmd_tool=%%~pdkbin\db2cmd.exe
                             set /A InstanceFound=1
                            )
                        )
                    )
                )
            )
        )
     rem ---
    )
    
for /F "tokens=1,2 delims=:" %%i in ('type %TMPFILE%') do (
     if not "  %InstanceName%"=="%%j" (
         db2swtch -l > %ILIST%
         for /F "tokens=1,*" %%i in ('find /v /i "default" %ILIST%') do (
             if %%j GTR . (
                 if not "%%j" == "%ILIST%" (
                     for /F  "delims=" %%k in ('echo %%j\') do (
                         for /F "delims=" %%x in ('"%%~pdkbin\db2ilist"') do (
                             if "%%x" == "%InstanceName%" (
                                 set db2audit_tool=%%~pdkbin\db2audit.exe
                                 set db2cmd_tool=%%~pdkbin\db2cmd.exe
                                 set /A InstanceFound=1
                                )
                            )
                        )
                    )
                )
            )
        ) else ( set /A InstanceFound=1 )
    )
    
    
if %InstanceFound% EQU 0 (
     echo %date% %time% Instance %InstanceName% does not exists.>> %ACTUATOR_LOG%
     echo %date% %time% Collect failed. >> %ACTUATOR_LOG%
     echo %date% %time% Processing finished. >> %ACTUATOR_LOG%
     exit /b 1
    )

if %InstanceFound% EQU 1 (
     "%db2cmd_tool%" -c -w "db2 -r %TMPFILE% get instance"
     if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Instance %InstanceName% does not exists.>> %ACTUATOR_LOG%
         echo %date% %time% Collect failed. >> %ACTUATOR_LOG%
         echo %date% %time% Processing finished. >> %ACTUATOR_LOG%
         exit /b 1
        )
    )   
  
rem for /F "tokens=1,2 delims=:" %%i in ('type %TMPFILE%') do (
    rem  if not "  %InstanceName%"=="%%j" (
         rem echo %date% %time% Instance %InstanceName% does not exists.>> %ACTUATOR_LOG%
         rem echo %date% %time% Collect failed. >> %ACTUATOR_LOG%
         rem echo %date% %time% Processing finished. >> %ACTUATOR_LOG%
         rem exit /b 1
         rem checking for instance on other DB2 copies

       rem  )
   rem  )
del %TMPFILE%

rem checking whether some of audit levels are disabled

rem checking default path
if "%DATABASE_ARCHIVE_PATH%"=="default" (
     for /F "tokens=1,2,3 delims=:" %%i in ('"%db2audit_tool%" describe') do (
         set TEMP=%%j:%%k
	     if "%%i" == "Audit Archive Path" (set DATABASE_ARCHIVE_PATH=%%j:%%k)
	    )
	 for /F "tokens=* delims= " %%i in ("!DATABASE_ARCHIVE_PATH!") do set DATABASE_ARCHIVE_PATH=%%~i
    )
	
if "%INSTANCE_ARCHIVE_PATH%"=="default" (
     for /F "tokens=1,2,3 delims=:" %%i in ('"%db2audit_tool%" describe') do (
         set TEMP=%%j:%%k
	     if "%%i" == "Audit Archive Path" (set INSTANCE_ARCHIVE_PATH=%%j:%%k)
	    )
	 for /F "tokens=* delims= " %%i in ("!INSTANCE_ARCHIVE_PATH!") do set INSTANCE_ARCHIVE_PATH=%%~i
    )

set DB_DISABLE=false 
set INST_DISABLE=false
if "%DATABASE_ARCHIVE_PATH%"=="skip" (set DB_DISABLE=true)   
if %DB_DISABLE%==true (echo %date% %time% Processing of database level is disabled. Database archive path is equal to "skip">> %ACTUATOR_LOG%)

if "%INSTANCE_ARCHIVE_PATH%"=="skip" (set INST_DISABLE=true)    
if %INST_DISABLE%==true (echo %date% %time% Processing of instance level is disabled. Instance archive path is equal to "skip" >> %ACTUATOR_LOG%)

set DATABASE_ARCHIVE_PATH="%DATABASE_ARCHIVE_PATH%\"
set INSTANCE_ARCHIVE_PATH="%INSTANCE_ARCHIVE_PATH%\"
for /F "delims=" %%I in ('echo %DATABASE_ARCHIVE_PATH%') do ( set DATABASE_ARCHIVE_PATH=%%~dpI)
for /F "delims=" %%I in ('echo %INSTANCE_ARCHIVE_PATH%') do ( set INSTANCE_ARCHIVE_PATH=%%~dpI)


rem analizing paths
if not exist "%INSTANCE_ARCHIVE_PATH%" (set INST_DISABLE=true
     echo %date% %time% Instance's archive path not valid - Instance level audit is disabled >> %ACTUATOR_LOG%
	)
	
if not exist "%DATABASE_ARCHIVE_PATH%" (set DB_DISABLE=true
	 echo %date% %time% Database's archive path not valid - Database level audit is disabled >> %ACTUATOR_LOG%
	)
rem ------------------------

rem trying instance level
if %INST_DISABLE%==false (
	 echo %date% %time% Instance level collect started. >> %ACTUATOR_LOG%
     rem archiving current logfile
	 rem db2audit archive to "%INSTANCE_ARCHIVE_PATH%\"
     "%db2audit_tool%" archive to "%INSTANCE_ARCHIVE_PATH%\"
	 if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to archive current logfile.>> %ACTUATOR_LOG%
        )
     rem getting list of the %INSTANCE_ARCHIVE_PATH%
     dir "%INSTANCE_ARCHIVE_PATH%%INSTANCE_FILE_PATTERN%.*" /b /a-d /on > %ARCHLIST_TMP%
     echo. >> %ARCHLIST_TMP%
     findstr /r [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$ %ARCHLIST_TMP% > %TMPFILE%
     copy %TMPFILE% %ARCHLIST_TMP%
     if exist %ARCHLIST% del %ARCHLIST%
     echo %date% %time% Creating list of eligible archives >> %ACTUATOR_LOG%
	 for /F %%i in ('type %ARCHLIST_TMP%') do (
      rem %%~xj contains the timestamp of each archive file - we are doing comparasion by timestamps, not by whole names of the archives
      for /F %%j in ("%%i") do (
	      rem LEQ is changed to LSS in order to use the same procedure in instance common collect. Otherwice last archive can be collected twice
	      if %DATE_BEFORE_INST% LSS %%~xj echo %%i >> %ARCHLIST%
        ) 
     )
     rem here we have %ARCHLIST%, 
     rem extracting eligible records
     type nul > %TEMP_FILE1%
     set LAST_INSTANCE_ARCHIVE=
     echo %date% %time% Processing archive logs: >> %ACTUATOR_LOG%
     rem checking if there are data to collect
     if not exist %ARCHLIST% (
         echo %date% %time% There are no data to collect for instance level. >> %ACTUATOR_LOG%
         echo %date% %time% Possible reasons: instance level path or pattern are wrong or there are no new events. >> %ACTUATOR_LOG%
        )
     for /F %%i in ('type %ARCHLIST%') do (
         set LAST_INSTANCE_ARCHIVE=%%i
	     echo %date% %time% Extracting archive %%i >> %ACTUATOR_LOG%
	     rem extracting archives
         "%db2audit_tool%" extract file %TEMP_FILE1% from files "%INSTANCE_ARCHIVE_PATH%%%i"
          if %ERRORLEVEL% NEQ 0 (
                 echo %date% %time% Unable to extract the archive.>> %ACTUATOR_LOG%
                ) else ( echo %date% %time% Archive is successfully exctracted.>> %ACTUATOR_LOG%)
	     rem for /F "delims=; tokens=*" %%c in ('"%db2audit_tool%" extract file %TEMP_FILE1% from files "%INSTANCE_ARCHIVE_PATH%%%i"') do (
		     rem if %ERRORLEVEL% NEQ 0 (
                 rem echo %date% %time% Unable to extract the archive.>> %ACTUATOR_LOG%
                rem )
	         rem echo %date% %time% %%c >> %ACTUATOR_LOG% 
			)           
        )
	)

rem saving name of the last extracted archive
if not "%LAST_INSTANCE_ARCHIVE%" == "" (echo lastinstfile=%LAST_INSTANCE_ARCHIVE% >> %TEMP_PROPS_FILE% )

rem packing original logs
rem copying %ARCHLIST% to %ALL_INST_ARCHLIST% 
if not "%INST_DISABLE%"=="true" (copy %ARCHLIST% %ALL_INST_ARCHLIST%)
if exist %TEMP_FILE3% del %TEMP_FILE3%
if %INST_DISABLE%==false (
 for /F %%a in ('type %ALL_INST_ARCHLIST%') do (
  echo paking - %%a
  echo %date% %time% packing original log %%a >> %ACTUATOR_LOG%
  if exist %TEMP_FILE3% (
    rem tar file exist
    ..\bin\bsdtar.exe -rf %TEMP_FILE3% "%INSTANCE_ARCHIVE_PATH%%%a"
	if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to pack %%a.>> %ACTUATOR_LOG%
    )
   ) else (
     rem tar file doesn't exist
	 ..\bin\bsdtar.exe -cf %TEMP_FILE3% "%INSTANCE_ARCHIVE_PATH%%%a"
	if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to pack %%a.>> %ACTUATOR_LOG%
    )
   )
 )
)

echo %date% %time% Instance level collect finished. >> %ACTUATOR_LOG%

rem trying database level
if %DB_DISABLE%==false (
	 echo %date% %time% Database level collect started. >> %ACTUATOR_LOG%
	 if exist %DATABASE_LIST% (del %DATABASE_LIST%)
     if exist %DATABASE_LIST_TMP% (del %DATABASE_LIST_TMP%)
     if exist %ALL_DB_ARCHLIST% (del %ALL_DB_ARCHLIST%)
     if exist %TMP_FC_FILE% (del %TMP_FC_FILE%)
     if exist %ARCHLIST_TMP% (del %ARCHLIST_TMP%)
     if exist %ARCHLIST% (del %ARCHLIST%)
     type nul > %TEMP_FILE2%
	 echo %date% %time% Getting list of the databases within instance %InstanceName% >> %ACTUATOR_LOG%
     "%db2cmd_tool%" -c -w "db2 -r %DATABASE_LIST_TMP% list database directory"
     if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to get list of the databases.>> %ACTUATOR_LOG%
         echo %date% %time% Collect of database level text dumps failed. >> %ACTUATOR_LOG%
        )
     for /F "tokens=1,2,3,4," %%i in ('type %DATABASE_LIST_TMP%') do (
         if "%%i %%j"=="Database name" (echo %%l >> %DATABASE_LIST%)
        )
	 rem  parsing pattern
	 for /F "delims=* tokens=1,2" %%i in ("%DATABASE_FILE_PATTERN%") do (
	     set FIRST_PART=%%i
		 set LAST_PART=%%j
	    )
	 for /F %%i in ('type %DATABASE_LIST%') do (	
	     if exist %ARCHLIST_TMP% (del %ARCHLIST_TMP%)
		 if exist %ARCHLIST% (del %ARCHLIST%)
         rem db2audit archive database %%i to "%DATABASE_ARCHIVE_PATH%\"
         "%db2audit_tool%" archive database %%i to "%DATABASE_ARCHIVE_PATH%\"
		 if %ERRORLEVEL% NEQ 0 (
             echo %date% %time% Unable to archive current logfile for database %%i .>> %ACTUATOR_LOG%
            )
         rem creating list of the archives		 
         for /F "delims=* tokens=1,2" %%j in ("%DATABASE_FILE_PATTERN%") do (
	         rem "FILE NOT FOUND" may appear here while trying to list archives of the database which is not being audited
             echo. >> %ARCHLIST_TMP%
             dir "%DATABASE_ARCHIVE_PATH%!FIRST_PART!%%i!LAST_PART!.*" /b /a-d /on > %ARCHLIST_TMP%	
             findstr /r [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$ %ARCHLIST_TMP% > %TMPFILE%
             copy %TMPFILE% %ARCHLIST_TMP%             
		    )			
         rem defining date to collect from
         for /F %%y in ('findstr .%%i. %PROPS_FILE%') do (
             set DATE_BEFORE_DB=%%~xy
            )
	     for /F %%k in ('type %ARCHLIST_TMP%') do (
             if !DATE_BEFORE_DB! LSS %%~xk (
			     echo %%k >> %ARCHLIST%
			    )			
            )
         rem archlist for each of database is ready here
              if not exist %ARCHLIST% (
                 echo %date% %time% There are no data to collect for database %%i. >> %ACTUATOR_LOG%
                 echo %date% %time% Possible reasons: database level path or pattern are wrong or there are no new events. >> %ACTUATOR_LOG%
                )
         type %ARCHLIST% >> %ALL_DB_ARCHLIST%
		 rem extracting text dumps
		 for /F %%s in ('type %ARCHLIST%') do (
	         echo %date% %time% Extracting archive %%s >> %ACTUATOR_LOG%
             "%db2audit_tool%" extract file %TEMP_FILE2% from files "%DATABASE_ARCHIVE_PATH%%%s"
             if %ERRORLEVEL% NEQ 0 (
                 echo %date% %time% Unable to extract the archive.>> %ACTUATOR_LOG%
                ) else ( echo %date% %time% Archive is successfully exctracted.>> %ACTUATOR_LOG%)
			 rem for /F "delims=; tokens=*" %%c in ('"%db2audit_tool%" extract file %TEMP_FILE2% from files "%DATABASE_ARCHIVE_PATH%%%s"') do (
			 	 rem if %ERRORLEVEL% NEQ 0 (
                     rem echo %date% %time% Unable to extract the archive.>> %ACTUATOR_LOG%
                   rem  )
	             rem echo %date% %time% %%c >> %ACTUATOR_LOG%
                 set LAST_DB_FILE=lastdbfile=%%s               
			    rem )	
			)
         if !LAST_DB_FILE! GTR . echo !LAST_DB_FILE!>> %TEMP_PROPS_FILE%
         set LAST_DB_FILE=
		)
	 rem sublog %TEMP_FILE2% is ready here
	)


rem packing original logs for database level
rem - packing
 if exist %TEMP_FILE4% del %TEMP_FILE4%
 if %DB_DISABLE%==false (
  for /F %%a in ('type %ALL_DB_ARCHLIST%') do (
   echo paking - %%a
   echo %date% %time% packing original log %%a >> %ACTUATOR_LOG%
   if exist %TEMP_FILE4% (
     rem tar file exist
     ..\bin\bsdtar.exe -rf %TEMP_FILE4% "%DATABASE_ARCHIVE_PATH%%%a"
     if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to pack %%a.>> %ACTUATOR_LOG%
    )
    ) else (
      rem tar file doesn't exist
 	 ..\bin\bsdtar.exe -cf %TEMP_FILE4% "%DATABASE_ARCHIVE_PATH%%%a"
     if %ERRORLEVEL% NEQ 0 (
         echo %date% %time% Unable to pack %%a.>> %ACTUATOR_LOG%
    )
 	)
  )
 )
rem merging propsfiles
if not exist %TEMP_PROPS_FILE% ( type nul > %TEMP_PROPS_FILE%)
echo %date% %time% Updating properties file... >> %ACTUATOR_LOG%
for /F %%i in ('type %PROPS_FILE%') do (
	 set propsstring=
	 for /F %%k in ('findstr %%~ni %TEMP_PROPS_FILE%') do (
	     set propsstring=%%~nk
	    )
	 if . GTR !propsstring! echo %%i >> %NEW_PROPS_FILE%
	)
copy %TEMP_PROPS_FILE% %PROPS_FILE% /Y
type %NEW_PROPS_FILE% >> %PROPS_FILE%
	
rem adding domain to propsfile
rem type nul > %NEW_PROPS_FILE%
del %NEW_PROPS_FILE%
set /A IS_DOMAIN_DEFINED=0
for /F "delims='=' tokens=1,2" %%i in ('type %PROPS_FILE%') do (
     if "%%i"=="_domain" (
         echo %%i=%USERDNSDOMAIN%>> %NEW_PROPS_FILE%
         set /A IS_DOMAIN_DEFINED=1
        ) else ( 
             echo %%i=%%j>> %NEW_PROPS_FILE%
            )
    )
if %IS_DOMAIN_DEFINED% EQU 0 (echo _domain=%USERDNSDOMAIN%>> %NEW_PROPS_FILE%)
copy %NEW_PROPS_FILE% %PROPS_FILE%
    
echo %date% %time% Database level collect finished. >> %ACTUATOR_LOG%

rem removing temporary dir
rmdir %PROPS_FILE%.dir /S /q

rem creating empty sublogs if necessary
if not exist %TEMP_FILE1% type nul > %TEMP_FILE1%
if not exist %TEMP_FILE2% type nul > %TEMP_FILE2%
if not exist %TEMP_FILE3% type nul > %TEMP_FILE3%
if not exist %TEMP_FILE4% type nul > %TEMP_FILE4%

echo %date% %time% Collect of new events is successful. >> %ACTUATOR_LOG%
echo %date% %time% Processing finished. >> %ACTUATOR_LOG%

exit /b 0
endlocal
