@echo off
set TEMP_FILE=%1
set INF_LOG_DIR=%~2
set INST_NAME=%3
set PROPS_FILE=%4
set LOG_FILE="..\log\%PROPS_FILE%.log"

echo [%date%][%time%] "Processing started ..."> %LOG_FILE%

if %TEMP_FILE% EQU "" (
  echo Failure: Missing output file argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if "%INF_LOG_DIR%" EQU "" (
  echo Failure: Missing DSN argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %INST_NAME% EQU "" (
  echo Failure: Missing username argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %PROPS_FILE% EQU "" (
  echo Failure: Missing property file argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if exist "%PROPS_FILE%" (
FOR /F "tokens=1-2* delims==" %%a IN ('findstr INFORMIX_PATH= %PROPS_FILE%') DO set INFORMIX_PATH=%%b
goto check1
) else (
"..\bin\getnewrecs.exe" %TEMP_FILE% %LOG_FILE% "%INF_LOG_DIR%\%INST_NAME%.*" "([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9]+:[0-9]+:[0-9]+\.[0-9]+)" %PROPS_FILE% 2880 >> %LOG_FILE% 2>&1
goto preend
)

:check1
if %INFORMIX_PATH% NEQ "%INF_LOG_DIR%" (
del %PROPS_FILE%
"..\bin\getnewrecs.exe" %TEMP_FILE% %LOG_FILE% "%INF_LOG_DIR%\%INST_NAME%.*" "([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9]+:[0-9]+:[0-9]+\.[0-9]+)" %PROPS_FILE% >> %LOG_FILE% 2>&1
goto preend
) else (
"..\bin\getnewrecs.exe" %TEMP_FILE% %LOG_FILE% "%INF_LOG_DIR%\%INST_NAME%.*" "([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9]+:[0-9]+:[0-9]+\.[0-9]+)" %PROPS_FILE% >> %LOG_FILE% 2>&1
goto end
)

:preend
echo INFORMIX_PATH="%INF_LOG_DIR%" >> %PROPS_FILE%
echo _domainname=%USERDOMAIN% >> %PROPS_FILE%
goto end

:end
if %errorlevel% EQU 1 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

echo [%date%][%time%] "Processing finished (Return code 0)" >> %LOG_FILE%
exit /b 0