#!/bin/ksh
###########################################################BeginFile############
# Copyright:  (c) 2007 All Rights Reserved
#
# Name:
#   getidslogs.sh
#
# Purpose:
#   Back-end actuator script for IBM INFORMIX DYNAMIC SERVER ES for UNIX platforms. 
#
# History:
#   070801 0.0.1  ScienceSoft  EE0705001:  Created.
#   070803 0.0.2  ScienceSoft  EE0705001:  Updated.
###########################################################EndFile############## 

function firstcollect { 
buffer=""
bigestindex="$FILEINDEX"
minindex="$FILEINDEX"
amount=0
for aa in `find "$LOGDIR" -name "$INSTNAME.*" -mtime -2 | sed -e 's/\.\///' | grep "\/$INSTNAME.[0-9][0-9]*$"`
do
  buffer="$aa $buffer"
  amount=`expr "$amount" + 1`
  lines=`wc -l "$aa" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
  LinesToCollect=`expr "$LinesToCollect" + "$lines"` 
     bigestindex=`echo "$aa" | sed -e "s/^.*$INSTNAME\.\([0-9][0-9]*\)$/\1/"`
     bigestindex=`expr "$bigestindex" + 0`
     FILEINDEX=`expr "$FILEINDEX" + 0`
     if [ "$bigestindex" -gt "$FILEINDEX" ]
     then
        FILEINDEX="$bigestindex"
     fi
done

if [ -z "$buffer" ]
then
   ##--------------------------------------------------------------------------------------------------------------------
   for aa in `find "$LOGDIR" -name "$INSTNAME.*" | sed -e 's/\.\///' | grep "\/$INSTNAME.[0-9][0-9]*$"`
   do
     bigestindex=`echo "$aa" | sed -e "s/^.*$INSTNAME\.\([0-9][0-9]*\)$/\1/"`
     bigestindex=`expr "$bigestindex" + 0`
     FILEINDEX=`expr "$FILEINDEX" + 0`
     if [ "$bigestindex" -gt "$FILEINDEX" ]
     then
        FILEINDEX="$bigestindex"
     fi
   done
   
   if [ -r "$LOGDIR/$INSTNAME.$FILEINDEX" ]
   then
     LASTLINE=`wc -l "$LOGDIR/$INSTNAME.$FILEINDEX" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   fi
   ##--------------------------------------------------------------------------------------------------------------------
   touch "$OUTPUTFILE"
   echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
   echo "null" >> "$CEA_GENACT_DEBUG_LOG"
   LinesAfterCollect=0
   echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

   mv "$PROPS.tmp" "$PROPS"
else
   echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
   echo "$buffer" >> "$CEA_GENACT_DEBUG_LOG"
   #-------------------------------------------------------------------------------
   buffer1=""
   while [ "$amount" -gt "0" ]; do
     testfile="$LOGDIR/$INSTNAME.$minindex"
     for aa in $buffer
     do
     if [ "$testfile" = "$aa" ]
       then
         amount=`expr "$amount" - 1`
         buffer1="$buffer1 $aa"
       fi
     done
     minindex=`expr "$minindex" + 1`
   done
   #-------------------------------------------------------------------------------
   for aa in $buffer1
   do
     cat "$aa" >> "$OUTPUTFILE"
   done
   LinesAfterCollect=`wc -l "$OUTPUTFILE" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   lastfilename="$LOGDIR/$INSTNAME.$FILEINDEX"
   LASTLINE=`wc -l "$lastfilename" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

   mv "$PROPS.tmp" "$PROPS" 
fi
}

function work_collect { 
buffer=""
tindex="$FILEINDEX"
minindex="$FILEINDEX"
amount=0
for aa in `ls "$LOGDIR" | grep "^$INSTNAME.[0-9][0-9]*$"`
do
   index=`echo "$aa" | sed -e "s/^$INSTNAME\.\([0-9][0-9]*\)$/\1/"`
   if [ "$index" -gt "$FILEINDEX" ]
   then
      lines=`wc -l "$LOGDIR/$aa" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
      LinesToCollect=`expr "$LinesToCollect" + "$lines"`
      buffer="$LOGDIR/$aa $buffer"
	  amount=`expr "$amount" + 1`
      if [ "$index" -gt "$tindex" ]
      then
         tindex="$index"
      fi
   fi
done

collect_additional

if [ -z "$buffer" ]
then
   if [ -r "$LOGDIR/$INSTNAME.$FILEINDEX" ]
   then
      LASTLINE=`wc -l "$LOGDIR/$INSTNAME.$FILEINDEX" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
      echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
      echo "$LOGDIR/$INSTNAME.$FILEINDEX" >> "$CEA_GENACT_DEBUG_LOG"
      LinesAfterCollect=`wc -l "$OUTPUTFILE" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
      echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

      mv "$PROPS.tmp" "$PROPS"
   else
      echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
      echo "null" >> "$CEA_GENACT_DEBUG_LOG"
   fi
else
   echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
   # may be add log from collect_additional fucntion?
   echo "$buffer" >> "$CEA_GENACT_DEBUG_LOG"
   #-------------------------------------------------------------------------------
   buffer1=""
   while [ "$amount" -gt "0" ]; do
     testfile="$LOGDIR/$INSTNAME.$minindex"
     for aa in $buffer
     do
       if [ "$testfile" = "$aa" ]
       then
         amount=`expr "$amount" - 1`
         buffer1="$buffer1 $aa"
       fi
       done
     minindex=`expr "$minindex" + 1`
   done
   #-------------------------------------------------------------------------------
   for aa in $buffer1
   do
     cat "$aa" >> "$OUTPUTFILE"
   done
   FILEINDEX="$tindex"
   lastfilename="$LOGDIR/$INSTNAME.$FILEINDEX"
   LASTLINE=`wc -l "$lastfilename" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   LinesAfterCollect=`wc -l "$OUTPUTFILE" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

   mv "$PROPS.tmp" "$PROPS" 
fi
}

function collect_additional {
if [ -r "$LOGDIR/$INSTNAME.$FILEINDEX" ]
then
  nline=`expr "$LASTLINE" + 1`
  lines=`wc -l "$LOGDIR/$INSTNAME.$FILEINDEX" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
  lines=`expr "$lines" - "$LASTLINE"`
  LinesToCollect=`expr "$LinesToCollect" + "$lines"`
  tail +"$nline" "$LOGDIR/$INSTNAME.$FILEINDEX" > "$OUTPUTFILE"
else
  touch "$OUTPUTFILE"
fi
}

function collect_all {
buffer=""
bigestindex="$FILEINDEX"
minindex="$FILEINDEX"
amount=0
for aa in `find "$LOGDIR" -name "$INSTNAME.*" | sed -e 's/\.\///' | grep "\/$INSTNAME.[0-9][0-9]*$"`
do
  buffer="$aa $buffer"
  amount=`expr "$amount" + 1`
  lines=`wc -l "$aa" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
  LinesToCollect=`expr "$LinesToCollect" + "$lines"` 
     bigestindex=`echo "$aa" | sed -e "s/^.*$INSTNAME\.\([0-9][0-9]*\)$/\1/"`
     bigestindex=`expr "$bigestindex" + 0`
     FILEINDEX=`expr "$FILEINDEX" + 0`
     if [ "$bigestindex" -gt "$FILEINDEX" ]
     then
        FILEINDEX="$bigestindex"
     fi
done

if [ -z "$buffer" ]
then
   touch "$OUTPUTFILE"
   echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
   echo "null" >> "$CEA_GENACT_DEBUG_LOG"
   LinesAfterCollect=0
   echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

   mv "$PROPS.tmp" "$PROPS"
else
   echo "Files for collect:" >> "$CEA_GENACT_DEBUG_LOG"
   echo "$buffer" >> "$CEA_GENACT_DEBUG_LOG"
   #-------------------------------------------------------------------------------
   buffer1=""
   while [ "$amount" -gt "0" ]; do
     testfile="$LOGDIR/$INSTNAME.$minindex"
     for aa in $buffer
     do
       if [ "$testfile" = "$aa" ]
       then
         amount=`expr "$amount" - 1`
         buffer1="$buffer1 $aa"
       fi
     done
     minindex=`expr "$minindex" + 1`
   done
   #-------------------------------------------------------------------------------
   for aa in $buffer1
   do
     cat "$aa" >> "$OUTPUTFILE"
   done
   LinesAfterCollect=`wc -l "$OUTPUTFILE" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   lastfilename="$LOGDIR/$INSTNAME.$FILEINDEX"
   LASTLINE=`wc -l "$lastfilename" | sed -e 's/^ *\([0-9]\{1,\}\).*/\1/'`
   echo "$INSTNAME.$FILEINDEX:$LASTLINE:$LOGDIR" > "$PROPS.tmp"

   mv "$PROPS.tmp" "$PROPS" 
fi
}

CEA_GENACT_DEBUG_LOG=../log/${PROPSFILE}.log
. $CEA_GENACT_FUNCLIB || exit 1
 
# Validate input 

[[ $# -ge 1 ]] \
  || exit 1

[[ -n "$OPTION2" ]] \
  || exit 1

[[ -n "$OPTION3" ]] \
  || exit 1

[[ -n "$PROPSFILE" ]] \
  || exit 1

OUTPUTFILE="$1" 
LOGDIR="$OPTION2"
INSTNAME="$OPTION3"
PROPS="$PROPSFILE"
LinesToCollect=0
LinesAfterCollect=0

FILEINDEX=0
LASTLINE=0
LASTDIR=""
BACKUPFILEINDEX="$FILEINDEX"
BACKUPLASTLINE="$LASTLINE"
BACKUPLASTDIR="$LASTDIR"

T=`date`
echo "Start collect $T" > "$CEA_GENACT_DEBUG_LOG"

if [ -r "$PROPSFILE" ]
then 
  iniprev=`cat "$PROPS" | grep "^$INSTNAME.[0-9][0-9]*"`
  if [ -n "$iniprev" ]
    then
    FILEINDEX=`cat $PROPS | grep "^$INSTNAME.[0-9][0-9]*" | sed -e "s/^$INSTNAME\.\([0-9][0-9]*\):[0-9][0-9]*:.*$/\1/"`
    LASTLINE=`cat $PROPS | grep "^$INSTNAME.[0-9][0-9]*" | sed -e "s/^$INSTNAME\.[0-9][0-9]*:\([0-9][0-9]*\):.*$/\1/"`
    LASTDIR=`cat $PROPS | grep "^$INSTNAME.[0-9][0-9]*" | sed -e "s/^$INSTNAME\.[0-9][0-9]*:[0-9][0-9]*:\(.*\)$/\1/"`
	BACKUPFILEINDEX="$FILEINDEX"
	BACKUPLASTLINE="$LASTLINE"
	BACKUPLASTDIR="$LASTDIR"
    if [ "$LASTDIR" != "$LOGDIR" ]
    then
       if [[ "$LASTLINE" = "0" && "$FILEINDEX" = "0" ]]
       then
          echo "again initial collect" >> "$CEA_GENACT_DEBUG_LOG"
          firstcollect
       else
          echo "directory had been changed - collecting all audit files" >> "$CEA_GENACT_DEBUG_LOG"
          FILEINDEX=0
          LASTLINE=0
          collect_all
       fi
    else
       if [[ "$LASTLINE" = "0" && "$FILEINDEX" = "0" ]]
       then
          echo "again initial collect" >> "$CEA_GENACT_DEBUG_LOG"
          firstcollect
       else
          echo "non-initial collect" >> "$CEA_GENACT_DEBUG_LOG"
          work_collect
       fi
    fi
  else
     echo "initial collect - wrong property file" >> "$CEA_GENACT_DEBUG_LOG"
     firstcollect
  fi
else
  echo "initial collect" >> "$CEA_GENACT_DEBUG_LOG"
  firstcollect
fi

if [ "$LinesToCollect" = "$LinesAfterCollect" ]
then
   T=`date`
   echo "Finish collect [success] $T" >> "$CEA_GENACT_DEBUG_LOG"
   exit 0
else
   echo "$INSTNAME.$BACKUPFILEINDEX:$BACKUPLASTLINE:$BACKUPLOGDIR" > "$PROPS.tmp"
   rm "$PROPS"
   mv "$PROPS.tmp" "$PROPS"
   T=`date`
   echo "Finish collect [fail] $T" >> "$CEA_GENACT_DEBUG_LOG"
   exit 1
fi
exit 0