@echo off

rem ----- Receive parameters from the TCIM actuator
set TEMP_FILE=%1
set FULLPATH=%2
for /F "delims=*" %%i in ("%FULLPATH%") do set FULLPATH=%%~i
set PROPS_FILE=%3

IF %TEMP_FILE% == "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 1
)

IF "%FULLPATH%" == "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log 
  exit /b 1
)
IF %PROPS_FILE% == "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log 
  exit /b 1
)
type nul> %TEMP_FILE%
type nul > ..\log\%PROPS_FILE%.log

rem -- create temp directory
mkdir %PROPS_FILE%.dir

@echo %date% %time% "Start processing" >> ..\log\%PROPS_FILE%.log

if EXIST "%FULLPATH%" (
  @echo %date% %time% "Active log file found" >> ..\log\%PROPS_FILE%.log
) ELSE (
  @echo %date% %time% "Active log file not found" >> ..\log\%PROPS_FILE%.log
  @echo %date% %time% "Finish processing (Return code 1)" >> ..\log\%PROPS_FILE%.log
  exit /b 1
)
@echo %date% %time% "Reading state information" >> ..\log\%PROPS_FILE%.log

rem --- set default values LAST, LINE, REPR
for /F %%i in ('..\bin\date.exe -d "2 days ago"  +"%%Y-%%m-%%d-%%H-%%M-%%S"') do set LAST=%%i
set /A LINE=0
set REPR=0

IF EXIST %PROPS_FILE% (
  for /F "tokens=1,2 delims==" %%i in ('findstr LINE %PROPS_FILE%') do (set TESTLINE=%%j)
  for /F "tokens=1,2 delims==" %%i in ('findstr LAST %PROPS_FILE%') do (set LAST=%%j)
  for /F "tokens=1,2 delims==" %%i in ('findstr REPR %PROPS_FILE%') do (set REPR="%%j")
) ELSE (
  @echo %date% %time% "This is the first collect" >> ..\log\%PROPS_FILE%.log
)

if not "%TESTLINE%"=="" (
  set LINE=%TESTLINE%
) 
rem --- save current state of directory
dir "%FULLPATH%*" /A-D /B /ON > %PROPS_FILE%.dir\tmp.lst

rem --- define define path
for /F "delims=*" %%p in ("%FULLPATH%") do set PATHTOLOG=%%~dp%%~pp

rem --- copy current log into temp directory
copy /y "%FULLPATH%" %PROPS_FILE%.dir\tmp.tmp

rem -- define last processed file in previous time
for /F %%i in ('type %PROPS_FILE%.dir\tmp.lst') do (
  IF not DEFINED frst (
    IF "%PATHTOLOG%%%i" GTR "%FULLPATH%.%LAST%" ( 
      set frst=%PATHTOLOG%%%i
      goto first
    )
  )
)
:first

@echo %date% %time% "Processing new files" >> ..\log\%PROPS_FILE%.log
for /F %%j in ('type %PROPS_FILE%.dir\tmp.lst') do (
  IF "%PATHTOLOG%%%j" GTR "%FULLPATH%.%LAST%" ( 
    IF "%frst%"=="%PATHTOLOG%%%j" (
      for /F "tokens=* delims==" %%i in ('findstr date "%PATHTOLOG%%%j"') do (
        if not DEFINED fndfrst (
          set fndfrst=1
            if """""%%i"""""=="%REPR%" (
              IF %LINE%==0 (
                type "%PATHTOLOG%%%j">> %TEMP_FILE%
                @echo %date% %time% " %PATHTOLOG%%%j file collected" >> ..\log\%PROPS_FILE%.log
              ) else ( 
                for /F "skip=%LINE% delims=" %%A in ('type "%PATHTOLOG%%%j"') do echo %%A>> %TEMP_FILE%
                @echo %date% %time% "%PATHTOLOG%%%j file collected. %LINE% lines skipped" >> ..\log\%PROPS_FILE%.log
              )
            ) else (
              type "%PATHTOLOG%%%j">> %TEMP_FILE%
              @echo %date% %time% " %PATHTOLOG%%%j file collected" >> ..\log\%PROPS_FILE%.log
            )
        )
      )
    ) ELSE (
      type "%PATHTOLOG%%%j">> %TEMP_FILE%
      @echo %date% %time% " %PATHTOLOG%%%j file collected" >> ..\log\%PROPS_FILE%.log
    )
  )
  set TMPLAST=%%~xj
)
for /F "delims=." %%i in ('echo %TMPLAST%') do set LAST=%%i
@echo %date% %time% "Last prosecced file is %FULLPATH%%TMPLAST%">> ..\log\%PROPS_FILE%.log

rem --- processing current log
@echo %date% %time% "Processing active log %FULLPATH%" >> ..\log\%PROPS_FILE%.log

set /A ACTUALCOUNT=0
for /F "tokens=* delims==" %%i in ('findstr date %PROPS_FILE%.dir\tmp.tmp') do (
  if not DEFINED fndfrstA (
    set fndfrstA=1
    if """""%%i"""""=="%REPR%" (
      IF %LINE%==0 (
        type %PROPS_FILE%.dir\tmp.tmp>> %TEMP_FILE% 
        @echo %date% %time% " %FULLPATH% file collected" >> ..\log\%PROPS_FILE%.log
        for /F "delims=" %%n in (%PROPS_FILE%.dir\tmp.tmp) do set /A ACTUALCOUNT+=1
      ) else ( 
        for /F "skip=%LINE% delims=" %%A in ('type "%PROPS_FILE%.dir\tmp.tmp"') do (
          set /A ACTUALCOUNT+=1
          echo %%A>> %TEMP_FILE%
        )
        set /A ACTUALCOUNT+=%LINE%
        @echo %date% %time% "%FULLPATH% file collected. %LINE% lines skipped" >> ..\log\%PROPS_FILE%.log
      )
    ) else (
      type %PROPS_FILE%.dir\tmp.tmp>> %TEMP_FILE%
      @echo %date% %time% " %FULLPATH% file collected" >> ..\log\%PROPS_FILE%.log
      for /F "delims=" %%n in (%PROPS_FILE%.dir\tmp.tmp) do set /A ACTUALCOUNT+=1
    )
  )
)

for /F "tokens=* delims==" %%i in ('findstr date %PROPS_FILE%.dir\tmp.tmp') do (
  set REPR=""%%i""
  goto setperp
)
:setperp


@echo %date% %time% "Saving state information" >> ..\log\%PROPS_FILE%.log
type nul > %PROPS_FILE%


@echo LINE=%ACTUALCOUNT%>>%PROPS_FILE%
@echo LAST=%LAST%>>%PROPS_FILE%
@echo REPR="%REPR%">>%PROPS_FILE%

@echo %date% %time% "Clearing temporary files" >> ..\log\%PROPS_FILE%.log
rmdir /S /Q %PROPS_FILE%.dir

@echo %date% %time% "Finish processing (Return code 0)" >> ..\log\%PROPS_FILE%.log
exit /b 0
