#!/bin/sh

mounth2num () {   
  case $1 in
    'Jan')
       outval="01"
       ;;
    'Feb')
       outval="02"
       ;;
    'Mar')
       outval="03"
       ;;
    'Apr')
       outval="04"
       ;;
    'May')
       outval="05"
       ;;
    'Jun')
       outval="06"
       ;;
    'Jul')
       outval="07"
       ;;
    'Aug')
       outval="08"
       ;;
    'Sep')
       outval="09"
       ;;
    'Oct')
       outval="10"
       ;;
    'Nov')
       outval="11"
       ;;
    'Dec')
       outval="12"
       ;;
     *)
       outval="00"
       ;;
  esac
  echo $outval
} 
first_collect()
{
  DATE_NOW=`date +"%d-%b-%Y"`
  TIME_NOW=`date +"%H:%M"`
  DATE_THEN=`../bin/goBackInTime $DATE_NOW $TIME_NOW 2880` 

  DD=`echo $DATE_THEN | sed -e "s/\(.*\)-.*-.* .*:.*/\1/"`
  MON=`echo $DATE_THEN | sed -e "s/.*-\(.*\)-.* .*:.*/\1/"`
  MON=`mounth2num $MON`
  YYYY=`echo $DATE_THEN | sed -e "s/.*-.*-\(.*\) .*:.*/\1/"`
  HH=`echo $DATE_THEN | sed -e "s/.*-.*-.* \(.*\):.*/\1/"`
  MM=`echo $DATE_THEN | sed -e "s/.*-.*-.* .*:\(.*\)/\1/"`
echo $base_name"."$YYYY-$MON-$DD-$HH-$MM-"00"
} 

## input parameters
temp_file=$TEMPFILE1
full_path=$OPTION2
props_file=$PROPSFILE


log_file="../log/$props_file.log"
echo "[`date`] Processing started" >$log_file

## check whether active log file path is correctly specified
if [ -f "$full_path" ]
then
  echo "[`date`] Active log file found" >>$log_file
else
  echo "[`date`] Active log file not found" >>$log_file
  echo "[`date`] Processing finished (Return code 1)" >>$log_file
  exit 1
fi

dir_name=`dirname $full_path`
base_name=`basename $full_path`


echo "[`date`] Reading state information" >>$log_file

rm -f $temp_file

touch $temp_file
## reading act. state information from the props file
if [ -f "$props_file" ] 
then
  full_log=`cat $props_file | head -n 1`
  log_lines=`cat $props_file | tail +2 | head -n 1`
  repr=`cat $props_file | tail +3`
else
  echo "[`date`] This is the first collect" >>$log_file
  full_log=`first_collect`
fi

if [ "a$log_lines" = "a" ] 
then
  log_lines="0";
fi

flag=""

## processing rotated files, i.e. file that already finalized
for log in `ls -1 $dir_name | grep "^$base_name" | sort | tail +2`
do
  if [ "a$full_log" != "a" ]
  then
    result=`expr "$log" \> "$full_log"`
    if [ $result -eq "1" ] 
    then
      echo "[`date`] Processing file: $log" >>$log_file
      if [ "a$flag" = "a" ]
      then
        flag="flag"
        log_lines_temp=`expr $log_lines + 1`
        if [ `cat $dir_name/$log | tail +2 | head -1` = $repr ]
        then
          tail +$log_lines_temp $dir_name/$log>> $temp_file
        else
         cat $dir_name/$log >> $temp_file
        fi
      else
        cat $dir_name/$log >> $temp_file
      fi
    fi
  else
    echo "[`date`] Processing file: $log" >>$log_file
    cat $dir_name/$log >> $temp_file
  fi
  new_full_log=$log
done

## determines number of lines at the active log file
new_log_lines=`cat $dir_name/$base_name | wc -l`

## reading active log file
echo "[`date`] Processing file: $base_name" >>$log_file
if [ "`cat $dir_name/$base_name | tail +2 | head -1`" = "$repr" ]
   then
    diff_log_lines=`expr $new_log_lines - $log_lines`
    tail -$diff_log_lines $dir_name/$base_name>> $temp_file
   else
    head -n "$new_log_lines" "$dir_name/$base_name">> $temp_file
fi

## writes state information to the props file
## reads new lines from the active log
echo $new_full_log > $props_file
echo $new_log_lines >> $props_file
echo `cat $dir_name/$base_name | tail +2 | head -1`>> $props_file

echo "[`date`] Processing finished (Return code 0)" >>$log_file
exit 0
