@echo off

set TEMP_FILE=%1
set LDAPHOST="empty"
set LDAPPORT=%3
set USERNAME=%4
set PASSWORD=%5
set PROPS_FILE=%6
set LOG_FILE="..\log\%PROPS_FILE%.log"

echo [%date%][%time%] "Processing started ..."> %LOG_FILE%


if exist %PROPS_FILE% (
  findstr "SystemName" %PROPS_FILE%> nul
  if NOT errorlevel 1 (
    for /F "tokens=1,2 delims==" %%i in ('findstr "SystemName" %PROPS_FILE%') do (
     set LDAPHOST=%%j
    )
  ) 
) 

if %LDAPHOST% EQU "empty" (
  echo Failure: Missing paramter SystemName from PROPS_FILE >> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %LDAPPORT% EQU "" (
  echo Failure: Missing LDAPPORT argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %TEMP_FILE% EQU "" (
  echo Failure: Missing OUTPUT_FILE argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

java  -classpath "../bin/getitdsgroups.jar" nl.consul.cea.gensub.itdsuis.java.CollectITDSGroups ~LDAPHost?%LDAPHOST% ~LDAPPort?%LDAPPORT%  ~UserName?%USERNAME% ~Password?%PASSWORD% ~Filename?%TEMP_FILE% 1>> %LOG_FILE% 2>&1
if %errorlevel% EQU 1 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

echo [%date%][%time%] "Processing finished" >> %LOG_FILE%

exit /b 0