#!/bin/ksh

# input parameters

TEMP_FILE=$1
LDAPHOST=""
LDAPPORT=$3
USERNAME=$4
PASSWORD=$5
PROPS_FILE=$6

act_log_file="../log/`basename $PROPSFILE`.log";
touch $act_log_file 

echo "[`date`] Processing started ...">$act_log_file;

LDAPHOST=`grep "SystemName" $PROPS_FILE | awk '{print $3}'`

if [ "$LDAPHOST" = "" ]; 
then
   echo "[`date`] Failure: Missing parameter SystemName from PROPS_FILE">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$LDAPPORT" = "" ]; 
then
   echo "[`date`] Failure: Missing LDAPPORT argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$TEMP_FILE" = "" ]; 
then
   echo "[`date`] Failure: Missing OUTPUT_FILE argument ">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

echo "[`date`] Collect user information source">>$act_log_file;
java  -classpath "../bin/getitdsgroups.jar" nl.consul.cea.gensub.itdsuis.java.CollectITDSGroups ~LDAPHost?$LDAPHOST ~LDAPPort?$LDAPPORT  ~UserName?$USERNAME ~Password?$PASSWORD ~Filename?$TEMP_FILE >>$act_log_file;

code=$?
if [ $code = 0 ];
then
   echo "[`date`] "Processing finished" ">>$act_log_file;
else
   echo "[`date`] Failure: Collect process failed Exit with code " $code>>$act_log_file;
   exit $code;
   exit
fi
exit 0
