#!/bin/ksh
# input parameters
TEMP_FILE=$TEMPFILE1
SRV_AUD=$OPTION2
SRV_AUD_ARCH=$OPTION3
PROPS_FILE=$PROPSFILE
PATH_JAVA=$OPTION11
ERROR_FILE="return";
act_log_file="../log/`basename $PROPSFILE`.log";
touch $act_log_file
touch $TEMPFILE1
touch $ERROR_FILE

if [ "$PROPS_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing property file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$TEMP_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing server audit log output file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$SRV_AUD" = "" ]; 
then
   echo "[`date`] ERROR: Active server audit log path is empty ">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$SRV_AUD_ARCH" = "" ]; 
then
   SRV_AUD_ARCH=$SRV_AUD
fi


echo "[`date`] Collect server audit logs">>$act_log_file;
if [ "$PATH_JAVA" = "" ]; 
then
PATH_JAVA="java"
else
PATH_JAVA=$PATH_JAVA"/java"
fi

$PATH_JAVA -classpath "../bin/getitdslogs.jar" nl.consul.cea.gensub.itds.java.GetITDSLogs ~temp_file?$TEMP_FILE ~act_log?$SRV_AUD ~aud_log_arch?$SRV_AUD_ARCH ~props_file?$PROPS_FILE 2>>$act_log_file 1>>$act_log_file;
code=$?

if [ $code = 0 ];
then
   echo "[`date`] Success collecting server audit logs.">>$act_log_file;
else
   echo "[`date`] ERROR: Failure collecting server audit logs. Error code $code">>$act_log_file;
fi

echo "code1 "$code>$ERROR_FILE;

exit 0
