#!/bin/ksh


# input parameters
TEMP_FILE=$TEMPFILE2
SRV_ERR=$OPTION4
SRV_ERR_ARCH=$OPTION5
PROPS_FILE=$PROPSFILE
PATH_JAVA=$OPTION11
ERROR_FILE="return";
act_log_file="../log/`basename $PROPSFILE`.log";
touch $act_log_file
touch $TEMPFILE2
if [ "$PROPS_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing property file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$TEMP_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing server error log output file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi  


if [ "$SRV_ERR" = "" ]; 
then
   echo "[`date`] ERROR: Active server error log path is empty ">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi
if [ "$SRV_ERR_ARCH" = "" ]; 
then
   SRV_ERR_ARCH=$SRV_ERR
fi


if [ "$PATH_JAVA" = "" ]; 
then
PATH_JAVA="java"
else
PATH_JAVA=$PATH_JAVA"/java"
fi


$PATH_JAVA  -classpath "../bin/getitdslogs.jar" nl.consul.cea.gensub.itds.java.GetITDSLogs ~temp_file?$TEMP_FILE ~act_log?$SRV_ERR ~aud_log_arch?$SRV_ERR_ARCH ~props_file?$PROPS_FILE 2>>$act_log_file 1>>$act_log_file;
code=$?
if [ $code = 0 ];
then
   echo "[`date`] Success collecting server error logs.">>$act_log_file;
else
   echo "[`date`] ERROR: Failure collecting server error logs. Error code $code" >>$act_log_file;   
fi
echo "code2 "$code>>$ERROR_FILE;
exit 0
