#!/bin/ksh


# input parameters
TEMP_FILE=$TEMPFILE3
ADM_DMN_AUD=$OPTION6
ADM_DMN_AUD_LOG_ARCH=$OPTION7 
PROPS_FILE=$PROPSFILE
PATH_JAVA=$OPTION11
ERROR_FILE="return";
act_log_file="../log/`basename $PROPSFILE`.log";
touch $act_log_file
 touch $TEMPFILE3

#clear actuator script log file

if [ "$PROPS_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing property file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$TEMP_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing server admin daemon audit log output file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi  
 
if [ "$ADM_DMN_AUD" = "" ]; 
then
   echo "[`date`] ERROR: Active admin daemon audit log path is empty ">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$ADM_DMN_AUD_LOG_ARCH" = "" ]; 
then
  ADM_DMN_AUD_LOG_ARCH=$ADM_DMN_AUD
fi


echo "[`date`] Collect admin audit logs">>$act_log_file;
if [ "$PATH_JAVA" = "" ]; 
then
PATH_JAVA="java"
else
PATH_JAVA=$PATH_JAVA"/java"
fi
$PATH_JAVA -classpath "../bin/getitdslogs.jar" nl.consul.cea.gensub.itds.java.GetITDSLogs ~temp_file?$TEMP_FILE ~act_log?$ADM_DMN_AUD ~aud_log_arch?$ADM_DMN_AUD_LOG_ARCH ~props_file?$PROPS_FILE 2>>$act_log_file 1>>$act_log_file;
code=$?
if [ $code = 0 ];
then
   echo "[`date`] Success collecting admin audit logs.">>$act_log_file;
else
   echo "[`date`] ERROR: Failure collecting admin audit logs. Error code $code">>$act_log_file;

fi

echo "code3 "$code>>$ERROR_FILE;
exit 0
