#!/bin/ksh


# input parameters
TEMP_FILE=$TEMPFILE4
ADM_DMN_ERR_LOG=$OPTION8
ADM_DMN_ERR_LOG_ARCH=$OPTION9
PROPS_FILE=$PROPSFILE
PATH_JAVA=$OPTION11
ERROR_FILE="return";
act_log_file="../log/`basename $PROPSFILE`.log";
touch $act_log_file
touch $TEMPFILE4
if [ "$PROPS_FILE" = "" ]; 
then
   echo "[`date`] ERROR: Missing property file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$TEMP_FILE" = "" ];
then
   echo "[`date`] ERROR: Missing admin daemon error log output file argument">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi

if [ "$ADM_DMN_ERR_LOG" = "" ]; 
then
   echo "[`date`] ERROR: Active admin daemon error log path is empty ">>$act_log_file;
   echo "[`date`] Processing finished (Return code 1)">>$act_log_file;
   exit 1;
fi
if [ "$ADM_DMN_ERR_LOG_ARCH" = "" ]; 
then
  ADM_DMN_ERR_LOG_ARCH=$ADM_DMN_ERR_LOG
fi

echo "[`date`] Collect admin audit error logs">>$act_log_file;
if [ "$PATH_JAVA" = "" ]; 
then
PATH_JAVA="java"
else
PATH_JAVA=$PATH_JAVA"/java"
fi
$PATH_JAVA  -classpath "../bin/getitdslogs.jar" nl.consul.cea.gensub.itds.java.GetITDSLogs ~temp_file?$TEMP_FILE ~act_log?$ADM_DMN_ERR_LOG ~aud_log_arch?$ADM_DMN_ERR_LOG_ARCH ~props_file?$PROPS_FILE 2>>$act_log_file 1>>$act_log_file;
code=$?
if [ $code = 0 ];
then
   echo "[`date`] Success collecting admin audit error. ">>$act_log_file;
else
   echo "[`date`] ERROR: Failure collecting admin audit error. Error code $code">>$act_log_file;
fi


echo "code4 "$code>>"return";
 bResults=`grep "code1 " $ERROR_FILE | awk '{print $2}'`
 bResulte=`grep "code2 " $ERROR_FILE | awk '{print $2}'`
 bResulta=`grep "code3 " $ERROR_FILE | awk '{print $2}'`
 bResultae=`grep "code4 " $ERROR_FILE | awk '{print $2}'`
 return_code=0;

if [  $bResults -ne 0 ];
then
   if [ $bResulte -ne 0 ];
   then
      if [  $bResulta -ne 0 ]; 
      then
         if [ $bResultae -ne 0 ];
         then
             rm $TEMPFILE1
             rm $TEMPFILE2
             rm $TEMPFILE3
             rm $TEMPFILE4
             echo "[`date`] ERROR: Failure collecting logs.">>$act_log_file;
             return_code=1;
         fi
      fi
   fi
fi
if [ $return_code = 0 ];
then
    echo "[`date`] SUCCESS: Finish collecting logs.">>$act_log_file;
fi
rm $ERROR_FILE
   exit  $return_code

