REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off

set TEMP_FILE=%1
set LDAPHOST="empty"
set LDAPPORT=%3
set USERLOCATION=%4
set GROUPLOCATION=%5
set USERNAME=%6
set PASSWORD=%7
set PROPS_FILE=%8
set LOG_FILE="..\log\%PROPS_FILE%.log"

echo [%date%][%time%] "Processing started ..."> %LOG_FILE%

if exist %PROPS_FILE% (
  findstr "SystemName" %PROPS_FILE%> nul
  if NOT errorlevel 1 (
    for /F "tokens=1,2 delims==" %%i in ('findstr "SystemName" %PROPS_FILE%') do (
     set LDAPHOST=%%j
    )
  ) 
) 

if %LDAPHOST% EQU "empty" (
  echo Failure: Missing paramter SystemName from PROPS_FILE >> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %LDAPPORT% EQU "" (
  echo Failure: Missing LDAPPORT argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %TEMP_FILE% EQU "" (
  echo Failure: Missing OUTPUT_FILE argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %USERLOCATION% EQU "" (
  echo Failure: Missing USERLOCATION argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %GROUPLOCATION% EQU "" (
  echo Failure: Missing GROUPLOCATION argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

java  -classpath "../bin/getitfimgroups.jar" nl.consul.cea.gensub.itfim.java.CollectITFIMGroups -LDAPHost?%LDAPHOST% -LDAPPort?%LDAPPORT% -UserLocation?%USERLOCATION% -GroupLocation?%GROUPLOCATION% -UserName?%USERNAME% -Password?%PASSWORD% -Filename?%TEMP_FILE% 1>> %LOG_FILE% 2>&1

if %errorlevel% EQU 1 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

echo [%date%][%time%] "Processing finished [SUCCESS]" >> %LOG_FILE%
exit /b 0