set TEMP_FILE1=%1
set TEMP_FILE2=%2
set CLEANUP=%3
set TRACE_PATH=%4
set USER_NAME=%5
set PASSWORD=%6
set PROPS_FILE=%7

type nul > ..\log\%PROPS_FILE%.log

if "%TEMP_FILE1%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)			
if "%TEMP_FILE2%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)
if %TRACE_PATH% EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)
if "%USER_NAME%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)

@echo %date% %time% "Processing started" >> ..\log\%PROPS_FILE%.log
mkdir %PROPS_FILE%.dir

dir /ON /A-D /B /S %TRACE_PATH%\audittrace*|findstr /V [a-z]*_..trc>%PROPS_FILE%.dir\listing.%PROPS_FILE%
@echo %date% %time% "Created listing of available Audit traces" >> ..\log\%PROPS_FILE%.log

if EXIST %PROPS_FILE% (
  for /F "delims=," %%I in ('findstr /V audittrace %PROPS_FILE%') DO (set LINE_NUM=%%I)
  for /F "delims=," %%I in ('findstr audittrace %PROPS_FILE%') DO (set PREV_FILE=%%I)
  goto NONFC
) else (
  goto FC
)


:NONFC
@echo %date% %time% "Properties file contents: %PREV_FILE% %LINE_NUM%" >> ..\log\%PROPS_FILE%.log
type nul>%PROPS_FILE%.dir\list
set /a OLD=%LINE_NUM%
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F 1 -L 2
  goto NEXT1
)
:NEXT1
if %errorlevel% NEQ 0 (
  @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
  GOTO EXIT
)
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  if "%PREV_FILE%" EQU "%%I" (
    bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F%LINE_NUM%
    if %errorlevel% NEQ 0 (
      @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
      GOTO EXIT
    )
    echo "%%I">>%PROPS_FILE%.dir\list
    @echo %date% %time% "Collect data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
    type "%PROPS_FILE%.dir\%%~nI.txt" >> %TEMP_FILE1%
  )

  if "%PREV_FILE%" LSS "%%I" (
    bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt
    if %errorlevel% NEQ 0 (
      @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
      GOTO EXIT
    )
    echo "%%I">>%PROPS_FILE%.dir\list
    @echo %date% %time% "Collect data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
    type "%PROPS_FILE%.dir\%%~nI.txt" >> %TEMP_FILE1%
    set /a OLD=0
  )
  set SAVE_VAL=%%I
  set COUNT_VAL=%PROPS_FILE%.dir\%%~nI.txt
)
echo %SAVE_VAL%>%PROPS_FILE%
set /a I=1
for /F "tokens=*" %%I in (%COUNT_VAL%) do (
  set /a I=I+1
)
set /a I=I+OLD
echo "%I%">>%PROPS_FILE%
goto TAR:


:FC
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F 1 -L 2
  goto NEXT2
)
:NEXT2
if %errorlevel% NEQ 0 (
  @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
  GOTO EXIT
)
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default) WHERE StartTime>GETDATE()-2" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt
  if %errorlevel% NEQ 0 (
    @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
    GOTO EXIT
  )
  for /F "delims=," %%K IN ('echo %PROPS_FILE%.dir\%%~nI.txt') do (
    if %%~zK GTR 0 (
      echo "%%I">>%PROPS_FILE%.dir\list
      @echo %date% %time% "Collect data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
    )
  )
  type "%PROPS_FILE%.dir\%%~nI.txt">>%TEMP_FILE1%
  set SAVE_VAL=%%I
  set COUNT_VAL=%PROPS_FILE%.dir\%%~nI.txt
)
echo %SAVE_VAL%>%PROPS_FILE%
set /a I=0
for /F "tokens=*" %%I in (%COUNT_VAL%) do (
   set /a I=I+1
)
if "%I%" EQU "0" (set /a I=I+1)
echo "%I%">>%PROPS_FILE%
goto TAR:


:TAR
if "%TEMP_FILE2%" EQU "6" (
  goto T:
)
for /F "delims=," %%I in ('type %PROPS_FILE%.dir\list') do (
  dir /ON /A-D /B /S "%%~dpI\%%~nI"*>>%PROPS_FILE%.dir\listall
)

for /F "delims=," %%I in ('type %PROPS_FILE%.dir\listall') do (
  if EXIST %TEMP_FILE2% (
    ..\bin\bsdtar.exe -rf %TEMP_FILE2% "%%I"
  ) ELSE (
    ..\bin\bsdtar.exe -cf %TEMP_FILE2% "%%I"
  )
)

@echo %date% %time% "Original logs archive created" >> ..\log\%PROPS_FILE%.log
goto T:


:T

del /Q %PROPS_FILE%.dir\listall
if "%CLEANUP%" EQU "yes" (
  @echo %date% %time% "Cleanup requested. Cleanning..." >> ..\log\%PROPS_FILE%.log
  for /F "delims=," %%I in ('type %PROPS_FILE%.dir\list') do (
    dir /ON /A-D /B /S "%%~dpI\%%~nI"*>>%PROPS_FILE%.dir\listall
  )
  for /F "delims=," %%I in ('type .\%PROPS_FILE%.dir\listall') DO (
    if "%%I" LSS "%SAVE_VAL%" (
      del /Q "%%~pI"\"%%~nI*"
    )
  )
  @echo %date% %time% "Cleanup finished" >> ..\log\%PROPS_FILE%.log
)
@echo %date% %time% "Processing finished (Return code 0)" >> ..\log\%PROPS_FILE%.log
rmdir /S /Q %PROPS_FILE%.dir
exit /b 0


:EXIT
rmdir /S /Q %PROPS_FILE%.dir
exit /b 1