#!/bin/sh

# input parameters
TEMP_FILE1=$1
GROUP=$2
USER=$3
PASSWORD=$4
CONF_PATH=$5
PROPS_FILE=$6
LOG_FILE="../log/$PROPS_FILE.log"
DATETIME=`date +[%d-%b-%Y]-[%H:%M:%S]`

if [ "$#" -lt "6" ]
then echo "$DATETIME" "Insufficient number of arguments!"
exit 1
fi

echo "$DATETIME" "Starting gettamosgroups applet..." >$LOG_FILE

if [ ! -r $CONF_PATH"/pdperm.properties" ]
    then echo "$DATETIME" "Configuration file not found! ("$CONF_PATH"/pdperm.properties)"  >>$LOG_FILE
echo "$DATETIME" "Trying to find ("$CONF_PATH"/pd.properties)"  >>$LOG_FILE
if [ ! -r $CONF_PATH"/pd.properties" ]
    then echo "$DATETIME" "Configuration file not found! ("$CONF_PATH"/pd.properties)"  >>$LOG_FILE
exit 1
fi
fi

TMP="../bin/gettamgroups.jar"

java -classpath $TMP nl.consul.cea.gensub.tamuis.java.gettamgroups $TEMP_FILE1 $USER $PASSWORD $CONF_PATH >> $LOG_FILE 2>&1

if [ `echo $?` -ne 0 ]
then echo "$DATETIME" "Processing finished [FAILURE]" >>$LOG_FILE
exit 1
fi

echo $DATETIME "Processing finished" >>$LOG_FILE
exit 0